
#define GROUND_COL	vec3(0.23, 0.23, 0.36)
#define SKY_COL		vec3(0.93, 0.93, 0.53)
#define SUN_POS		vec3(0.0, 100.0, 0.0)

uniform mat4 WorldMatrix;
uniform float timeSeconds;

void main(void)
{
	gl_TexCoord[0] = gl_TextureMatrix[0] * gl_MultiTexCoord0;
	
	vec3 worldPos = (WorldMatrix*gl_Vertex).xyz;
	vec3 normal = normalize(gl_Normal.xyz);
	
	gl_Position = ftransform();//gl_ProjectionMatrix * gl_ModelViewMatrix * gl_Vertex;
	
	gl_FrontColor = vec4(
			mix(GROUND_COL, SKY_COL, 0.5 + 0.5 * dot(normal, normalize(SUN_POS - worldPos))),
    		1.0
			)
			* gl_Color;
	
	// Cloud shadow texture coordinate.
	worldPos *= 0.025;
	vec2 offset = vec2(timeSeconds) * 0.01;
	gl_TexCoord[1] = vec4(worldPos.x+offset.x, worldPos.z+offset.y, 0.0, 1.0);
	gl_TexCoord[1].z = normal.y;
}
